#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Nov 14 17:26:46 2020

@author: gilles
"""


chiffres=[i for i in range(1,10)]

def arran(n,tab): # recherche de tous les arrangements de 3 chiffres parmi 9
    if n==1:
        liste=[]
        for i in tab:
            liste.append([i])
        return liste
    else:
        liste=arran(n-1,tab)
        nliste=[]
        for i in tab:
            for j in range(len(liste)):
                if i not in liste[j]:
                    nliste.append([i]+liste[j])
        return nliste


def tab_to_nb(tab): # transformation d'un tableau de chiffres en un entier
    nb=0
    p=100
    for i in tab:
        nb=nb+i*p
        p=p//10
    return nb

def chiffres_n(n): # extraction des chiffres d'un entier inférieur à 9999
    un=n%10
    n=n//10
    dn=n%10
    n=n//10
    cn=n%10
    n=n//10
    mn=n%10
    return un,dn,cn,mn # unités, dizaines, centaines, milliers

def nb_dans_tab(n,t): # test de la présence des chiffres d'un entier dans un tableau
    un,dn,cn,mn=chiffres_n(n)
    return (un in t) or (dn in t) or (cn in t) or (mn in t)

def nb_sans_doub(n): # test de la présence de doublons dans les chiffres d'un nombre
    un,dn,cn,mn=chiffres_n(n)
    return (un!=dn) and (un!=cn) and (dn!=cn)

def nb_3_chiffres(n):
    return n<1000

def nb_sans_0(n): # test de la présence d'un 0 dans le nombre
    un,dn,cn,mn=chiffres_n(n)
    return un!=0 and dn!=0 and cn!=0

def inter_vide(t1,t2):  # vérification que deux tableaux n'ont pas d'élément commun
    for e in t1:
        for f in t2:
            if e==f:
                return False
    return True

def probleme(): # résolution du problème
    result=[]
    nbs=arran(3,chiffres)
    for nb1 in nbs:
        for nb2 in nbs:  # nb1 et nb2 sont deux tableaux de trois chiffres
            if inter_vide(nb1,nb2): # on vérifie que nb1 et nb2 n'ont pas de chiffre en commun
                nb1n=tab_to_nb(nb1) # on convertit nb1 et nb2 en entiers
                nb2n=tab_to_nb(nb2)
                add=nb1n+nb2n
                if nb1n<nb2n and not(nb_dans_tab(add, nb1)) and not(nb_dans_tab(add, nb2)) and nb_sans_doub(add) and nb_sans_0(add) and nb_3_chiffres(add):
                    # validation de la somme de nb1n et nb1n  
                    result.append(str(nb1n)+" + "+str(nb2n)+" = "+str(add))
    return result

# écriture des résulats dans un fichier

fd=open("resultat1_9.txt",'+w')
res=probleme()
for el in res:
    fd.write(el+"\n")
fd.close()
